Index: /LMDZ5/trunk/libf/phylmd/phys_output_mod.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/phys_output_mod.F90	(revision 1538)
+++ /LMDZ5/trunk/libf/phylmd/phys_output_mod.F90	(revision 1539)
@@ -945,24 +1095,40 @@
 
  IF (ok_ade) THEN
-  CALL histdef2d(iff,o_topswad%flag,o_topswad%name, "ADE at TOA", "W/m2")
-  CALL histdef2d(iff,o_solswad%flag,o_solswad%name, "ADE at SRF", "W/m2")
-
- CALL histdef2d(iff,o_swtoaas_nat%flag,o_swtoaas_nat%name, "Natural aerosol radiative forcing all-sky at TOA", "W/m2")
- CALL histdef2d(iff,o_swsrfas_nat%flag,o_swsrfas_nat%name, "Natural aerosol radiative forcing all-sky at SRF", "W/m2")
- CALL histdef2d(iff,o_swtoacs_nat%flag,o_swtoacs_nat%name, "Natural aerosol radiative forcing clear-sky at TOA", "W/m2")
- CALL histdef2d(iff,o_swsrfcs_nat%flag,o_swsrfcs_nat%name, "Natural aerosol radiative forcing clear-sky at SRF", "W/m2")
-
- CALL histdef2d(iff,o_swtoaas_ant%flag,o_swtoaas_ant%name, "Anthropogenic aerosol radiative forcing all-sky at TOA", "W/m2")
- CALL histdef2d(iff,o_swsrfas_ant%flag,o_swsrfas_ant%name, "Anthropogenic aerosol radiative forcing all-sky at SRF", "W/m2")
- CALL histdef2d(iff,o_swtoacs_ant%flag,o_swtoacs_ant%name, "Anthropogenic aerosol radiative forcing clear-sky at TOA", "W/m2")
- CALL histdef2d(iff,o_swsrfcs_ant%flag,o_swsrfcs_ant%name, "Anthropogenic aerosol radiative forcing clear-sky at SRF", "W/m2")
+  CALL histdef2d(iff,clef_stations(iff), &
+o_topswad%flag,o_topswad%name, "ADE at TOA", "W/m2")
+  CALL histdef2d(iff,clef_stations(iff), &
+o_solswad%flag,o_solswad%name, "ADE at SRF", "W/m2")
+
+ CALL histdef2d(iff,clef_stations(iff), &
+o_swtoaas_nat%flag,o_swtoaas_nat%name, "Natural aerosol radiative forcing all-sky at TOA", "W/m2")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_swsrfas_nat%flag,o_swsrfas_nat%name, "Natural aerosol radiative forcing all-sky at SRF", "W/m2")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_swtoacs_nat%flag,o_swtoacs_nat%name, "Natural aerosol radiative forcing clear-sky at TOA", "W/m2")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_swsrfcs_nat%flag,o_swsrfcs_nat%name, "Natural aerosol radiative forcing clear-sky at SRF", "W/m2")
+
+ CALL histdef2d(iff,clef_stations(iff), &
+o_swtoaas_ant%flag,o_swtoaas_ant%name, "Anthropogenic aerosol radiative forcing all-sky at TOA", "W/m2")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_swsrfas_ant%flag,o_swsrfas_ant%name, "Anthropogenic aerosol radiative forcing all-sky at SRF", "W/m2")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_swtoacs_ant%flag,o_swtoacs_ant%name, "Anthropogenic aerosol radiative forcing clear-sky at TOA", "W/m2")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_swsrfcs_ant%flag,o_swsrfcs_ant%name, "Anthropogenic aerosol radiative forcing clear-sky at SRF", "W/m2")
 
  IF (.NOT. aerosol_couple) THEN 
- CALL histdef2d(iff,o_swtoacf_nat%flag,o_swtoacf_nat%name, "Natural aerosol impact on cloud radiative forcing at TOA", "W/m2")
- CALL histdef2d(iff,o_swsrfcf_nat%flag,o_swsrfcf_nat%name, "Natural aerosol impact on cloud radiative forcing  at SRF", "W/m2")
- CALL histdef2d(iff,o_swtoacf_ant%flag,o_swtoacf_ant%name, "Anthropogenic aerosol impact on cloud radiative forcing at TOA", "W/m2")
- CALL histdef2d(iff,o_swsrfcf_ant%flag,o_swsrfcf_ant%name, "Anthropogenic aerosol impact on cloud radiative forcing at SRF", "W/m2")
- CALL histdef2d(iff,o_swtoacf_zero%flag,o_swtoacf_zero%name, "Cloud radiative forcing (allsky-clearsky fluxes) at TOA", "W/m2")
- CALL histdef2d(iff,o_swsrfcf_zero%flag,o_swsrfcf_zero%name, "Cloud radiative forcing (allsky-clearsky fluxes) at SRF", "W/m2")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_swtoacf_nat%flag,o_swtoacf_nat%name, "Natural aerosol impact on cloud radiative forcing at TOA", "W/m2")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_swsrfcf_nat%flag,o_swsrfcf_nat%name, "Natural aerosol impact on cloud radiative forcing  at SRF", "W/m2")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_swtoacf_ant%flag,o_swtoacf_ant%name, "Anthropogenic aerosol impact on cloud radiative forcing at TOA", "W/m2")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_swsrfcf_ant%flag,o_swsrfcf_ant%name, "Anthropogenic aerosol impact on cloud radiative forcing at SRF", "W/m2")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_swtoacf_zero%flag,o_swtoacf_zero%name, "Cloud radiative forcing (allsky-clearsky fluxes) at TOA", "W/m2")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_swsrfcf_zero%flag,o_swsrfcf_zero%name, "Cloud radiative forcing (allsky-clearsky fluxes) at SRF", "W/m2")
  ENDIF
 
@@ -970,45 +1136,206 @@
 
  IF (ok_aie) THEN
-  CALL histdef2d(iff,o_topswai%flag,o_topswai%name, "AIE at TOA", "W/m2")
-  CALL histdef2d(iff,o_solswai%flag,o_solswai%name, "AIE at SFR", "W/m2")
+  CALL histdef2d(iff,clef_stations(iff), &
+o_topswai%flag,o_topswai%name, "AIE at TOA", "W/m2")
+  CALL histdef2d(iff,clef_stations(iff), &
+o_solswai%flag,o_solswai%name, "AIE at SFR", "W/m2")
 !Cloud droplet number concentration
-  CALL histdef3d(iff,o_scdnc%flag,o_scdnc%name, "Cloud droplet number concentration","m-3")
-  CALL histdef2d(iff,o_cldncl%flag,o_cldncl%name, "CDNC at top of liquid water cloud", "m-3")
-  CALL histdef3d(iff,o_reffclws%flag,o_reffclws%name, "Stratiform Cloud Droplet Effective Radius","m")
-  CALL histdef3d(iff,o_reffclwc%flag,o_reffclwc%name, "Convective Cloud Droplet Effective Radius","m")
-  CALL histdef2d(iff,o_cldnvi%flag,o_cldnvi%name, "Column Integrated Cloud Droplet Number", "m-2")
-  CALL histdef3d(iff,o_lcc3d%flag,o_lcc3d%name, "Cloud liquid fraction","1")
-  CALL histdef3d(iff,o_lcc3dcon%flag,o_lcc3dcon%name, "Convective cloud liquid fraction","1")
-  CALL histdef3d(iff,o_lcc3dstra%flag,o_lcc3dstra%name, "Stratiform cloud liquid fraction","1")
-  CALL histdef2d(iff,o_lcc%flag,o_lcc%name, "Cloud liquid fraction at top of cloud","1")
-  CALL histdef2d(iff,o_reffclwtop%flag,o_reffclwtop%name, "Droplet effective radius at top of liquid water cloud", "m")
+  CALL histdef3d(iff,clef_stations(iff), &
+o_scdnc%flag,o_scdnc%name, "Cloud droplet number concentration","m-3")
+  CALL histdef2d(iff,clef_stations(iff), &
+o_cldncl%flag,o_cldncl%name, "CDNC at top of liquid water cloud", "m-3")
+  CALL histdef3d(iff,clef_stations(iff), &
+o_reffclws%flag,o_reffclws%name, "Stratiform Cloud Droplet Effective Radius (aerosol diags.)","m")
+  CALL histdef3d(iff,clef_stations(iff), &
+o_reffclwc%flag,o_reffclwc%name, "Convective Cloud Droplet Effective Radius (aerosol diags.)","m")
+  CALL histdef2d(iff,clef_stations(iff), &
+o_cldnvi%flag,o_cldnvi%name, "Column Integrated Cloud Droplet Number", "m-2")
+  CALL histdef3d(iff,clef_stations(iff), &
+o_lcc3d%flag,o_lcc3d%name, "Cloud liquid fraction","1")
+  CALL histdef3d(iff,clef_stations(iff), &
+o_lcc3dcon%flag,o_lcc3dcon%name, "Convective cloud liquid fraction","1")
+  CALL histdef3d(iff,clef_stations(iff), &
+o_lcc3dstra%flag,o_lcc3dstra%name, "Stratiform cloud liquid fraction","1")
+  CALL histdef2d(iff,clef_stations(iff), &
+o_lcc%flag,o_lcc%name, "Cloud liquid fraction at top of cloud","1")
+  CALL histdef2d(iff,clef_stations(iff), &
+o_reffclwtop%flag,o_reffclwtop%name, "Droplet effective radius at top of liquid water cloud", "m")
  ENDIF
 
 
- CALL histdef2d(iff,o_alb1%flag,o_alb1%name, "Surface VIS albedo", "-")
- CALL histdef2d(iff,o_alb2%flag,o_alb2%name, "Surface Near IR albedo", "-")
- CALL histdef2d(iff,o_cdrm%flag,o_cdrm%name, "Momentum drag coef.", "-")
- CALL histdef2d(iff,o_cdrh%flag,o_cdrh%name, "Heat drag coef.", "-" )
- CALL histdef2d(iff,o_cldl%flag,o_cldl%name, "Low-level cloudiness", "-")
- CALL histdef2d(iff,o_cldm%flag,o_cldm%name, "Mid-level cloudiness", "-")
- CALL histdef2d(iff,o_cldh%flag,o_cldh%name, "High-level cloudiness", "-")
- CALL histdef2d(iff,o_cldt%flag,o_cldt%name, "Total cloudiness", "-")
- CALL histdef2d(iff,o_cldq%flag,o_cldq%name, "Cloud liquid water path", "kg/m2")
- CALL histdef2d(iff,o_lwp%flag,o_lwp%name, "Cloud water path", "kg/m2")
- CALL histdef2d(iff,o_iwp%flag,o_iwp%name, "Cloud ice water path", "kg/m2" )
- CALL histdef2d(iff,o_ue%flag,o_ue%name, "Zonal energy transport", "-")
- CALL histdef2d(iff,o_ve%flag,o_ve%name, "Merid energy transport", "-")
- CALL histdef2d(iff,o_uq%flag,o_uq%name, "Zonal humidity transport", "-")
- CALL histdef2d(iff,o_vq%flag,o_vq%name, "Merid humidity transport", "-")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_alb1%flag,o_alb1%name, "Surface VIS albedo", "-")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_alb2%flag,o_alb2%name, "Surface Near IR albedo", "-")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_cdrm%flag,o_cdrm%name, "Momentum drag coef.", "-")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_cdrh%flag,o_cdrh%name, "Heat drag coef.", "-" )
+ CALL histdef2d(iff,clef_stations(iff), &
+o_cldl%flag,o_cldl%name, "Low-level cloudiness", "-")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_cldm%flag,o_cldm%name, "Mid-level cloudiness", "-")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_cldh%flag,o_cldh%name, "High-level cloudiness", "-")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_cldt%flag,o_cldt%name, "Total cloudiness", "-")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_cldq%flag,o_cldq%name, "Cloud liquid water path", "kg/m2")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_lwp%flag,o_lwp%name, "Cloud water path", "kg/m2")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_iwp%flag,o_iwp%name, "Cloud ice water path", "kg/m2" )
+ CALL histdef2d(iff,clef_stations(iff), &
+o_ue%flag,o_ue%name, "Zonal energy transport", "-")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_ve%flag,o_ve%name, "Merid energy transport", "-")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_uq%flag,o_uq%name, "Zonal humidity transport", "-")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_vq%flag,o_vq%name, "Merid humidity transport", "-")
 
      IF(iflag_con.GE.3) THEN ! sb
- CALL histdef2d(iff,o_cape%flag,o_cape%name, "Conv avlbl pot ener", "J/kg")
- CALL histdef2d(iff,o_pbase%flag,o_pbase%name, "Cld base pressure", "Pa")
- CALL histdef2d(iff,o_ptop%flag,o_ptop%name, "Cld top pressure", "Pa")
- CALL histdef2d(iff,o_fbase%flag,o_fbase%name, "Cld base mass flux", "kg/m2/s")
- CALL histdef2d(iff,o_plcl%flag,o_plcl%name, "Lifting Condensation Level", "hPa")
- CALL histdef2d(iff,o_plfc%flag,o_plfc%name, "Level of Free Convection", "hPa")
- CALL histdef2d(iff,o_wbeff%flag,o_wbeff%name, "Conv. updraft velocity at LFC", "m/s")
- CALL histdef2d(iff,o_prw%flag,o_prw%name, "Precipitable water", "kg/m2")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_cape%flag,o_cape%name, "Conv avlbl pot ener", "J/kg")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_pbase%flag,o_pbase%name, "Cld base pressure", "Pa")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_ptop%flag,o_ptop%name, "Cld top pressure", "Pa")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_fbase%flag,o_fbase%name, "Cld base mass flux", "kg/m2/s")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_plcl%flag,o_plcl%name, "Lifting Condensation Level", "hPa")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_plfc%flag,o_plfc%name, "Level of Free Convection", "hPa")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_wbeff%flag,o_wbeff%name, "Conv. updraft velocity at LFC", "m/s")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_prw%flag,o_prw%name, "Precipitable water", "kg/m2")
+  IF (.NOT.clef_stations(iff)) THEN 
+!
+!IM: there is no way to have one single value in a netcdf file
+!
+    type_ecri(1) = 't_max(X)'
+    type_ecri(2) = 't_max(X)'
+    type_ecri(3) = 't_max(X)'
+    type_ecri(4) = 't_max(X)'
+    type_ecri(5) = 't_max(X)'
+    type_ecri(6) = 't_max(X)'
+    CALL histdef2d(iff,clef_stations(iff), &
+  o_cape_max%flag,o_cape_max%name, "CAPE max.", "J/kg")
+  ENDIF
+   type_ecri(:) = type_ecri_files(:)
+ CALL histdef3d(iff,clef_stations(iff), &
+o_upwd%flag,o_upwd%name, "saturated updraft", "kg/m2/s")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_Ma%flag,o_Ma%name, "undilute adiab updraft", "kg/m2/s")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dnwd%flag,o_dnwd%name, "saturated downdraft", "kg/m2/s")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dnwd0%flag,o_dnwd0%name, "unsat. downdraft", "kg/m2/s")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_mc%flag,o_mc%name, "Convective mass flux", "kg/m2/s")
+   type_ecri(1) = 'inst(X)'
+   type_ecri(2) = 'inst(X)'
+   type_ecri(3) = 'inst(X)'
+   type_ecri(4) = 'inst(X)'
+   type_ecri(5) = 'inst(X)'
+   type_ecri(6) = 'inst(X)'
+ CALL histdef2d(iff,clef_stations(iff), &
+o_ftime_con%flag,o_ftime_con%name, "Fraction of time convection Occurs", " ")
+   type_ecri(:) = type_ecri_files(:)
+     ENDIF !iflag_con .GE. 3
+
+ CALL histdef2d(iff,clef_stations(iff), &
+o_s_pblh%flag,o_s_pblh%name, "Boundary Layer Height", "m")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_s_pblt%flag,o_s_pblt%name, "t at Boundary Layer Height", "K")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_s_lcl%flag,o_s_lcl%name, "Condensation level", "m")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_s_therm%flag,o_s_therm%name, "Exces du thermique", "K")
+!IM : Les champs suivants (s_oliqCL, s_cteiCL, s_trmb1, s_trmb2, s_trmb3) ne sont pas definis dans HBTM.F
+!CALL histdef2d(iff,clef_stations(iff), &
+!o_s_capCL%flag,o_s_capCL%name, "Conv avlbl pot enerfor ABL", "J/m2" )
+!CALL histdef2d(iff,clef_stations(iff), &
+!o_s_oliqCL%flag,o_s_oliqCL%name, "Liq Water in BL", "kg/m2")
+!CALL histdef2d(iff,clef_stations(iff), &
+!o_s_cteiCL%flag,o_s_cteiCL%name, "Instability criteria(ABL)", "K")
+!CALL histdef2d(iff,clef_stations(iff), &
+!o_s_trmb1%flag,o_s_trmb1%name, "deep_cape(HBTM2)", "J/m2")
+!CALL histdef2d(iff,clef_stations(iff), &
+!o_s_trmb2%flag,o_s_trmb2%name, "inhibition (HBTM2)", "J/m2")
+!CALL histdef2d(iff,clef_stations(iff), &
+!o_s_trmb3%flag,o_s_trmb3%name, "Point Omega (HBTM2)", "m")
+
+! Champs interpolles sur des niveaux de pression
+
+   type_ecri(1) = 'inst(X)'
+   type_ecri(2) = 'inst(X)'
+   type_ecri(3) = 'inst(X)'
+   type_ecri(4) = 'inst(X)'
+   type_ecri(5) = 'inst(X)'
+   type_ecri(6) = 'inst(X)'
+
+! Attention a reverifier
+
+        ilev=0        
+        DO k=1, nlevSTD
+     bb2=clevSTD(k)
+     IF(bb2.EQ."850".OR.bb2.EQ."700".OR.bb2.EQ."500".OR.bb2.EQ."200" &
+.OR.bb2.EQ."100".OR.bb2.EQ."50".OR.bb2.EQ."10")THEN
+      ilev=ilev+1
+!     print*,'ilev k bb2 flag name ',ilev,k, bb2,o_uSTDlevs(ilev)%flag,o_uSTDlevs(ilev)%name
+ CALL histdef2d(iff,clef_stations(iff), &
+o_uSTDlevs(ilev)%flag,o_uSTDlevs(ilev)%name,"Zonal wind "//bb2//"hPa", "m/s")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_vSTDlevs(ilev)%flag,o_vSTDlevs(ilev)%name,"Meridional wind "//bb2//"hPa", "m/s")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_wSTDlevs(ilev)%flag,o_wSTDlevs(ilev)%name,"Vertical wind "//bb2//"hPa", "Pa/s")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_zSTDlevs(ilev)%flag,o_zSTDlevs(ilev)%name,"Geopotential height "//bb2//"hPa", "m")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_qSTDlevs(ilev)%flag,o_qSTDlevs(ilev)%name,"Specific humidity "//bb2//"hPa", "kg/kg" )
+ CALL histdef2d(iff,clef_stations(iff), &
+o_tSTDlevs(ilev)%flag,o_tSTDlevs(ilev)%name,"Temperature "//bb2//"hPa", "K")
+     ENDIF !(bb2.EQ."850".OR.bb2.EQ."700".OR."500".OR.bb2.EQ."200".OR.bb2.EQ."50".OR.bb2.EQ."10")
+       ENDDO
+   type_ecri(:) = type_ecri_files(:)
+
+ CALL histdef2d(iff,clef_stations(iff), &
+o_t_oce_sic%flag,o_t_oce_sic%name, "Temp mixte oce-sic", "K")
+
+ IF (type_ocean=='slab') & 
+     CALL histdef2d(iff,clef_stations(iff), &
+o_slab_bils%flag, o_slab_bils%name,"Bilan au sol sur ocean slab", "W/m2")
+
+! Couplage conv-CL
+ IF (iflag_con.GE.3) THEN
+    IF (iflag_coupl>=1) THEN
+ CALL histdef2d(iff,clef_stations(iff), &
+o_ale_bl%flag,o_ale_bl%name, "ALE BL", "m2/s2") 
+ CALL histdef2d(iff,clef_stations(iff), &
+o_alp_bl%flag,o_alp_bl%name, "ALP BL", "m2/s2") 
+    ENDIF
+ ENDIF !(iflag_con.GE.3)
+
+ CALL histdef2d(iff,clef_stations(iff), &
+o_weakinv%flag,o_weakinv%name, "Weak inversion", "-")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_dthmin%flag,o_dthmin%name, "dTheta mini", "K/m")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_rh2m%flag,o_rh2m%name, "Relative humidity at 2m", "%" )
+
+  IF (.NOT.clef_stations(iff)) THEN 
+!
+!IM: there is no way to have one single value in a netcdf file
+!
+   type_ecri(1) = 't_min(X)'
+   type_ecri(2) = 't_min(X)'
+   type_ecri(3) = 't_min(X)'
+   type_ecri(4) = 't_min(X)'
+   type_ecri(5) = 't_min(X)'
+   type_ecri(6) = 't_min(X)'
+   CALL histdef2d(iff,clef_stations(iff),o_rh2m_min%flag,o_rh2m_min%name, "Min Relative humidity at 2m", "%" )
    type_ecri(1) = 't_max(X)'
    type_ecri(2) = 't_max(X)'
@@ -1016,81 +1343,94 @@
    type_ecri(4) = 't_max(X)'
    type_ecri(5) = 't_max(X)'
- CALL histdef2d(iff,o_cape_max%flag,o_cape_max%name, "CAPE max.", "J/kg")
+   type_ecri(6) = 't_max(X)'
+   CALL histdef2d(iff,clef_stations(iff),o_rh2m_max%flag,o_rh2m_max%name, "Max Relative humidity at 2m", "%" )
+  ENDIF  
+
    type_ecri(:) = type_ecri_files(:)
- CALL histdef3d(iff,o_upwd%flag,o_upwd%name, "saturated updraft", "kg/m2/s")
- CALL histdef3d(iff,o_Ma%flag,o_Ma%name, "undilute adiab updraft", "kg/m2/s")
- CALL histdef3d(iff,o_dnwd%flag,o_dnwd%name, "saturated downdraft", "kg/m2/s")
- CALL histdef3d(iff,o_dnwd0%flag,o_dnwd0%name, "unsat. downdraft", "kg/m2/s")
- CALL histdef3d(iff,o_mc%flag,o_mc%name, "Convective mass flux", "kg/m2/s")
-   type_ecri(1) = 'inst(X)'
-   type_ecri(2) = 'inst(X)'
-   type_ecri(3) = 'inst(X)'
-   type_ecri(4) = 'inst(X)'
-   type_ecri(5) = 'inst(X)'
- CALL histdef2d(iff,o_ftime_con%flag,o_ftime_con%name, "Fraction of time convection Occurs", " ")
-   type_ecri(:) = type_ecri_files(:)
-     ENDIF !iflag_con .GE. 3
-
- CALL histdef2d(iff,o_s_pblh%flag,o_s_pblh%name, "Boundary Layer Height", "m")
- CALL histdef2d(iff,o_s_pblt%flag,o_s_pblt%name, "t at Boundary Layer Height", "K")
- CALL histdef2d(iff,o_s_lcl%flag,o_s_lcl%name, "Condensation level", "m")
- CALL histdef2d(iff,o_s_therm%flag,o_s_therm%name, "Exces du thermique", "K")
-!IM : Les champs suivants (s_oliqCL, s_cteiCL, s_trmb1, s_trmb2, s_trmb3) ne sont pas definis dans HBTM.F
-!CALL histdef2d(iff,o_s_capCL%flag,o_s_capCL%name, "Conv avlbl pot enerfor ABL", "J/m2" )
-!CALL histdef2d(iff,o_s_oliqCL%flag,o_s_oliqCL%name, "Liq Water in BL", "kg/m2")
-!CALL histdef2d(iff,o_s_cteiCL%flag,o_s_cteiCL%name, "Instability criteria(ABL)", "K")
-!CALL histdef2d(iff,o_s_trmb1%flag,o_s_trmb1%name, "deep_cape(HBTM2)", "J/m2")
-!CALL histdef2d(iff,o_s_trmb2%flag,o_s_trmb2%name, "inhibition (HBTM2)", "J/m2")
-!CALL histdef2d(iff,o_s_trmb3%flag,o_s_trmb3%name, "Point Omega (HBTM2)", "m")
-
-! Champs interpolles sur des niveaux de pression
-
-   type_ecri(1) = 'inst(X)'
-   type_ecri(2) = 'inst(X)'
-   type_ecri(3) = 'inst(X)'
-   type_ecri(4) = 'inst(X)'
-   type_ecri(5) = 'inst(X)'
-
-! Attention a reverifier
-
-        ilev=0        
-        DO k=1, nlevSTD
-!     IF(k.GE.2.AND.k.LE.12) bb2=clevSTD(k)
-     bb2=clevSTD(k)
-     IF(bb2.EQ."850".OR.bb2.EQ."700".OR.bb2.EQ."500".OR.bb2.EQ."200".OR.bb2.EQ."50".OR.bb2.EQ."10")THEN
-      ilev=ilev+1
-      print*,'ilev k bb2 flag name ',ilev,k, bb2,o_uSTDlevs(ilev)%flag,o_uSTDlevs(ilev)%name
- CALL histdef2d(iff,o_uSTDlevs(ilev)%flag,o_uSTDlevs(ilev)%name,"Zonal wind "//bb2//"hPa", "m/s")
- CALL histdef2d(iff,o_vSTDlevs(ilev)%flag,o_vSTDlevs(ilev)%name,"Meridional wind "//bb2//"hPa", "m/s")
- CALL histdef2d(iff,o_wSTDlevs(ilev)%flag,o_wSTDlevs(ilev)%name,"Vertical wind "//bb2//"hPa", "Pa/s")
- CALL histdef2d(iff,o_zSTDlevs(ilev)%flag,o_zSTDlevs(ilev)%name,"Geopotential height "//bb2//"hPa", "m")
- CALL histdef2d(iff,o_qSTDlevs(ilev)%flag,o_qSTDlevs(ilev)%name,"Specific humidity "//bb2//"hPa", "kg/kg" )
- CALL histdef2d(iff,o_tSTDlevs(ilev)%flag,o_tSTDlevs(ilev)%name,"Temperature "//bb2//"hPa", "K")
-     ENDIF !(bb2.EQ."850".OR.bb2.EQ."700".OR."500".OR.bb2.EQ."200".OR.bb2.EQ."50".OR.bb2.EQ."10")
-       ENDDO
-   type_ecri(:) = type_ecri_files(:)
-
- CALL histdef2d(iff,o_t_oce_sic%flag,o_t_oce_sic%name, "Temp mixte oce-sic", "K")
-
- IF (type_ocean=='slab') & 
-     CALL histdef2d(iff,o_slab_bils%flag, o_slab_bils%name,"Bilan au sol sur ocean slab", "W/m2")
-
-! Couplage conv-CL
- IF (iflag_con.GE.3) THEN
-    IF (iflag_coupl>=1) THEN
- CALL histdef2d(iff,o_ale_bl%flag,o_ale_bl%name, "ALE BL", "m2/s2") 
- CALL histdef2d(iff,o_alp_bl%flag,o_alp_bl%name, "ALP BL", "m2/s2") 
-    ENDIF
- ENDIF !(iflag_con.GE.3)
-
- CALL histdef2d(iff,o_weakinv%flag,o_weakinv%name, "Weak inversion", "-")
- CALL histdef2d(iff,o_dthmin%flag,o_dthmin%name, "dTheta mini", "K/m")
- CALL histdef2d(iff,o_rh2m%flag,o_rh2m%name, "Relative humidity at 2m", "%" )
-   type_ecri(1) = 't_min(X)'
-   type_ecri(2) = 't_min(X)'
-   type_ecri(3) = 't_min(X)'
-   type_ecri(4) = 't_min(X)'
-   type_ecri(5) = 't_min(X)'
- CALL histdef2d(iff,o_rh2m_min%flag,o_rh2m_min%name, "Min Relative humidity at 2m", "%" )
+ CALL histdef2d(iff,clef_stations(iff),o_qsat2m%flag,o_qsat2m%name, "Saturant humidity at 2m", "%")
+ CALL histdef2d(iff,clef_stations(iff),o_tpot%flag,o_tpot%name, "Surface air potential temperature", "K")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_tpote%flag,o_tpote%name, "Surface air equivalent potential temperature", "K")
+ CALL histdef2d(iff,clef_stations(iff),o_SWnetOR%flag,o_SWnetOR%name, "Sfce net SW radiation OR", "W/m2")
+ CALL histdef2d(iff,clef_stations(iff),o_SWdownOR%flag,o_SWdownOR%name, "Sfce incident SW radiation OR", "W/m2")
+ CALL histdef2d(iff,clef_stations(iff),o_LWdownOR%flag,o_LWdownOR%name, "Sfce incident LW radiation OR", "W/m2")
+ CALL histdef2d(iff,clef_stations(iff),o_snowl%flag,o_snowl%name, "Solid Large-scale Precip.", "kg/(m2*s)")
+
+ CALL histdef2d(iff,clef_stations(iff),o_solldown%flag,o_solldown%name, "Down. IR rad. at surface", "W/m2")
+ CALL histdef2d(iff,clef_stations(iff),o_dtsvdfo%flag,o_dtsvdfo%name, "Boundary-layer dTs(o)", "K/s")
+ CALL histdef2d(iff,clef_stations(iff),o_dtsvdft%flag,o_dtsvdft%name, "Boundary-layer dTs(t)", "K/s")
+ CALL histdef2d(iff,clef_stations(iff),o_dtsvdfg%flag,o_dtsvdfg%name, "Boundary-layer dTs(g)", "K/s")
+ CALL histdef2d(iff,clef_stations(iff),o_dtsvdfi%flag,o_dtsvdfi%name, "Boundary-layer dTs(g)", "K/s")
+ CALL histdef2d(iff,clef_stations(iff),o_rugs%flag,o_rugs%name, "rugosity", "-" )
+
+! Champs 3D:
+ CALL histdef3d(iff,clef_stations(iff),o_ec550aer%flag,o_ec550aer%name, "Extinction at 550nm", "m^-1")
+ CALL histdef3d(iff,clef_stations(iff),o_lwcon%flag,o_lwcon%name, "Cloud liquid water content", "kg/kg")
+ CALL histdef3d(iff,clef_stations(iff),o_iwcon%flag,o_iwcon%name, "Cloud ice water content", "kg/kg")
+ CALL histdef3d(iff,clef_stations(iff),o_temp%flag,o_temp%name, "Air temperature", "K" )
+ CALL histdef3d(iff,clef_stations(iff),o_theta%flag,o_theta%name, "Potential air temperature", "K" )
+ CALL histdef3d(iff,clef_stations(iff),o_ovap%flag,o_ovap%name, "Specific humidity", "kg/kg" )
+ CALL histdef3d(iff,clef_stations(iff), &
+o_ovapinit%flag,o_ovapinit%name, "Specific humidity (begin of timestep)", "kg/kg" )
+ CALL histdef3d(iff,clef_stations(iff), &
+o_geop%flag,o_geop%name, "Geopotential height", "m2/s2")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_vitu%flag,o_vitu%name, "Zonal wind", "m/s" )
+ CALL histdef3d(iff,clef_stations(iff), &
+o_vitv%flag,o_vitv%name, "Meridional wind", "m/s" )
+ CALL histdef3d(iff,clef_stations(iff), &
+o_vitw%flag,o_vitw%name, "Vertical wind", "Pa/s" )
+ CALL histdef3d(iff,clef_stations(iff), &
+o_pres%flag,o_pres%name, "Air pressure", "Pa" )
+ CALL histdef3d(iff,clef_stations(iff), &
+o_paprs%flag,o_paprs%name, "Air pressure Inter-Couches", "Pa" )
+ CALL histdef3d(iff,clef_stations(iff), &
+o_mass%flag,o_mass%name, "Masse Couches", "kg/m2" )
+ CALL histdef3d(iff,clef_stations(iff), &
+o_zfull%flag,o_zfull%name, "Altitude of full pressure levels", "m" )
+ CALL histdef3d(iff,clef_stations(iff), &
+o_zhalf%flag,o_zhalf%name, "Altitude of half pressure levels", "m" )
+ CALL histdef3d(iff,clef_stations(iff), &
+o_rneb%flag,o_rneb%name, "Cloud fraction", "-")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_rnebcon%flag,o_rnebcon%name, "Convective Cloud Fraction", "-")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_rhum%flag,o_rhum%name, "Relative humidity", "-")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_ozone%flag,o_ozone%name, "Ozone mole fraction", "-")
+ if (read_climoz == 2) &
+      CALL histdef3d(iff,clef_stations(iff), &
+o_ozone_light%flag,o_ozone_light%name, &
+      "Daylight ozone mole fraction", "-")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dtphy%flag,o_dtphy%name, "Physics dT", "K/s")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dqphy%flag,o_dqphy%name, "Physics dQ", "(kg/kg)/s")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_cldtau%flag,o_cldtau%name, "Cloud optical thickness", "1")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_cldemi%flag,o_cldemi%name, "Cloud optical emissivity", "1")
+!IM: bug ?? dimensionnement variables (klon,klev+1) pmflxr, pmflxs, prfl, psfl
+ CALL histdef3d(iff,clef_stations(iff), &
+o_pr_con_l%flag,o_pr_con_l%name, "Convective precipitation lic", " ")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_pr_con_i%flag,o_pr_con_i%name, "Convective precipitation ice", " ")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_pr_lsc_l%flag,o_pr_lsc_l%name, "Large scale precipitation lic", " ")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_pr_lsc_i%flag,o_pr_lsc_i%name, "Large scale precipitation ice", " ")
+!Cloud droplet effective radius
+ CALL histdef3d(iff,clef_stations(iff), &
+o_re%flag,o_re%name, "Cloud droplet effective radius","um")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_fl%flag,o_fl%name, "Denominator of Cloud droplet effective radius"," ")
+!FH Sorties pour la couche limite
+     if (iflag_pbl>1) then
+ CALL histdef3d(iff,clef_stations(iff), &
+o_tke%flag,o_tke%name, "TKE", "m2/s2")
+  IF (.NOT.clef_stations(iff)) THEN 
+!
+!IM: there is no way to have one single value in a netcdf file
+!
    type_ecri(1) = 't_max(X)'
    type_ecri(2) = 't_max(X)'
@@ -1098,58 +1438,17 @@
    type_ecri(4) = 't_max(X)'
    type_ecri(5) = 't_max(X)'
- CALL histdef2d(iff,o_rh2m_max%flag,o_rh2m_max%name, "Max Relative humidity at 2m", "%" )
+   type_ecri(6) = 't_max(X)'
+   CALL histdef3d(iff,clef_stations(iff), &
+  o_tke_max%flag,o_tke_max%name, "TKE max", "m2/s2")
+  ENDIF 
    type_ecri(:) = type_ecri_files(:)
- CALL histdef2d(iff,o_qsat2m%flag,o_qsat2m%name, "Saturant humidity at 2m", "%")
- CALL histdef2d(iff,o_tpot%flag,o_tpot%name, "Surface air potential temperature", "K")
- CALL histdef2d(iff,o_tpote%flag,o_tpote%name, "Surface air equivalent potential temperature", "K")
- CALL histdef2d(iff,o_SWnetOR%flag,o_SWnetOR%name, "Sfce net SW radiation OR", "W/m2")
- CALL histdef2d(iff,o_SWdownOR%flag,o_SWdownOR%name, "Sfce incident SW radiation OR", "W/m2")
- CALL histdef2d(iff,o_LWdownOR%flag,o_LWdownOR%name, "Sfce incident LW radiation OR", "W/m2")
- CALL histdef2d(iff,o_snowl%flag,o_snowl%name, "Solid Large-scale Precip.", "kg/(m2*s)")
-
- CALL histdef2d(iff,o_solldown%flag,o_solldown%name, "Down. IR rad. at surface", "W/m2")
- CALL histdef2d(iff,o_dtsvdfo%flag,o_dtsvdfo%name, "Boundary-layer dTs(o)", "K/s")
- CALL histdef2d(iff,o_dtsvdft%flag,o_dtsvdft%name, "Boundary-layer dTs(t)", "K/s")
- CALL histdef2d(iff,o_dtsvdfg%flag,o_dtsvdfg%name, "Boundary-layer dTs(g)", "K/s")
- CALL histdef2d(iff,o_dtsvdfi%flag,o_dtsvdfi%name, "Boundary-layer dTs(g)", "K/s")
- CALL histdef2d(iff,o_rugs%flag,o_rugs%name, "rugosity", "-" )
-
-! Champs 3D:
- CALL histdef3d(iff,o_ec550aer%flag,o_ec550aer%name, "Extinction at 550nm", "m^-1")
- CALL histdef3d(iff,o_lwcon%flag,o_lwcon%name, "Cloud liquid water content", "kg/kg")
- CALL histdef3d(iff,o_iwcon%flag,o_iwcon%name, "Cloud ice water content", "kg/kg")
- CALL histdef3d(iff,o_temp%flag,o_temp%name, "Air temperature", "K" )
- CALL histdef3d(iff,o_theta%flag,o_theta%name, "Potential air temperature", "K" )
- CALL histdef3d(iff,o_ovap%flag,o_ovap%name, "Specific humidity", "kg/kg" )
- CALL histdef3d(iff,o_ovapinit%flag,o_ovapinit%name, "Specific humidity (begin of timestep)", "kg/kg" )
- CALL histdef3d(iff,o_geop%flag,o_geop%name, "Geopotential height", "m2/s2")
- CALL histdef3d(iff,o_vitu%flag,o_vitu%name, "Zonal wind", "m/s" )
- CALL histdef3d(iff,o_vitv%flag,o_vitv%name, "Meridional wind", "m/s" )
- CALL histdef3d(iff,o_vitw%flag,o_vitw%name, "Vertical wind", "Pa/s" )
- CALL histdef3d(iff,o_pres%flag,o_pres%name, "Air pressure", "Pa" )
- CALL histdef3d(iff,o_paprs%flag,o_paprs%name, "Air pressure Inter-Couches", "Pa" )
- CALL histdef3d(iff,o_mass%flag,o_mass%name, "Masse Couches", "kg/m2" )
- CALL histdef3d(iff,o_rneb%flag,o_rneb%name, "Cloud fraction", "-")
- CALL histdef3d(iff,o_rnebcon%flag,o_rnebcon%name, "Convective Cloud Fraction", "-")
- CALL histdef3d(iff,o_rhum%flag,o_rhum%name, "Relative humidity", "-")
- CALL histdef3d(iff,o_ozone%flag,o_ozone%name, "Ozone mole fraction", "-")
- if (read_climoz == 2) &
-      CALL histdef3d(iff,o_ozone_light%flag,o_ozone_light%name, &
-      "Daylight ozone mole fraction", "-")
- CALL histdef3d(iff,o_dtphy%flag,o_dtphy%name, "Physics dT", "K/s")
- CALL histdef3d(iff,o_dqphy%flag,o_dqphy%name, "Physics dQ", "(kg/kg)/s")
- CALL histdef3d(iff,o_cldtau%flag,o_cldtau%name, "Cloud optical thickness", "1")
- CALL histdef3d(iff,o_cldemi%flag,o_cldemi%name, "Cloud optical emissivity", "1")
-!IM: bug ?? dimensionnement variables (klon,klev+1) pmflxr, pmflxs, prfl, psfl
- CALL histdef3d(iff,o_pr_con_l%flag,o_pr_con_l%name, "Convective precipitation lic", " ")
- CALL histdef3d(iff,o_pr_con_i%flag,o_pr_con_i%name, "Convective precipitation ice", " ")
- CALL histdef3d(iff,o_pr_lsc_l%flag,o_pr_lsc_l%name, "Large scale precipitation lic", " ")
- CALL histdef3d(iff,o_pr_lsc_i%flag,o_pr_lsc_i%name, "Large scale precipitation ice", " ")
-!Cloud droplet effective radius
- CALL histdef3d(iff,o_re%flag,o_re%name, "Cloud droplet effective radius","um")
- CALL histdef3d(iff,o_fl%flag,o_fl%name, "Denominator of Cloud droplet effective radius"," ")
-!FH Sorties pour la couche limite
-     if (iflag_pbl>1) then
- CALL histdef3d(iff,o_tke%flag,o_tke%name, "TKE", "m2/s2")
+     endif
+
+ CALL histdef3d(iff,clef_stations(iff), &
+o_kz%flag,o_kz%name, "Kz melange", "m2/s")
+  IF (.NOT.clef_stations(iff)) THEN 
+!
+!IM: there is no way to have one single value in a netcdf file
+!
    type_ecri(1) = 't_max(X)'
    type_ecri(2) = 't_max(X)'
